// $Id: relatedlinks.js,v 1.4 2008/02/17 08:56:48 karthik Exp $

$(document).ready(function() {
  var ta = $('#edit-relatedlinks-fieldset-relatedlinks');
  $(ta).parents('div.form-item').hide();
  var top = $(ta).parents('fieldset');

  // Parse textarea for links and store them in a global array.
  l = $(ta).val().split("\n");
  r = new RegExp('\w*([^\ \w]+)\ *(.*)$', 'i');
  links = new Array();
  for (var i = 0; i < l.length; i++) {
    m = l[i].match(r);
    if (m) {
      link_set(m[1], m[2], i);
    }
  }

  // -1 signifies that no link is being edited at the moment.
  current = -1;

  // Insert URL and title textfields.
  var fields = $('<div class="relatedlinks clear-block"><div id="relatedlinks-preview"></div><div class="relatedlinks-url"><div class="form-item"><label for="field-relatedlinks-url">URL:</label><input id="field-relatedlinks-url" class="form-text" type="text" value="" size="60" name="relatedlinks-url" maxlength="128" /></div></div><div class="relatedlinks-title"><div class="form-item"><label for="field-relatedlinks-title">Title:</label><input id="field-relatedlinks-title" class="form-text" type="text" value="" size="60" name="relatedlinks-title" maxlength="128" /></div></div></div>')
    .appendTo(top);
  var preview = $('#relatedlinks-preview', fields);

  links_preview();
  var l = $('<a id="relatedlinks-add" href="#">Add / Update</a>')
    .appendTo(fields)
    .click(function() {
      url = $('#field-relatedlinks-url', fields).val();
      if (url.length) {
        if (current == -1) {
          link_set(url, $('#field-relatedlinks-title', fields).val(), links.length);
        }
        else {
          link_set(url, $('#field-relatedlinks-title', fields).val(), current);
        }
        $('#field-relatedlinks-title', fields).val('');
        $('#field-relatedlinks-url', fields).val('');
      }
      links_preview();
      return false;
    }
  );

  var l = $('<a id="relatedlinks-clear" href="#">Clear</a>')
    .appendTo(fields)
    .click(function() {
      current = -1;
      $('#field-relatedlinks-url', fields).val('');
      $('#field-relatedlinks-title', fields).val('');
      return false;
    }
  );


  function links_preview() {
    // Remove the preview list. This function is called after every event and
    // the list is just recreated every time based on the textarea input.
    $('ol', preview).remove();
    set = $('<ol></ol>').appendTo(preview);

    l = '';
    for (var i = 0; i < links.length; i++) {
      // Create textarea input.
      l += links[i].url + ' ' + links[i].title + "\n";

      // Trim and check if title is available; else use the URL as the title.
      links[i].title = $.trim(links[i].title);
      title = links[i].title.length ? links[i].title : links[i].url;

      // Add edit button.
      actions = '<a class="relatedlinks-action relatedlinks-edit" title="Edit this link.">Edit</a>';
      // Add delete button.
      actions += '<a class="relatedlinks-action relatedlinks-delete" title="Delete this link.">Delete</a>';

      // If available, add the up button.
      if (i > 0) {
        actions += '<a class="relatedlinks-action relatedlinks-up" title="Move this link one row up.">Up</a>';
      }
      // If available, add the down button.
      if (i < links.length - 1) {
        actions += '<a class="relatedlinks-action relatedlinks-down" title="Move this link one row down.">Down</a>';
      }

      // Insert action buttons.
      $('<li><a class="relatedlinks-link" href="' + links[i].url + '">' + title + '</a>' + actions + '</li>')
        .appendTo(set);
    }

    // Handle edit button clicks: populate URL and title fields with clicked
    // link value.
    $('.relatedlinks-edit', set).each(function(k) {
      $(this).click(function() {
        // Track the currently edited link ID.
        current = k;
        $('#field-relatedlinks-url', fields).val(links[current].url);
        $('#field-relatedlinks-title', fields).val(links[current].title);
        return false;
      });
    });

    // Handle delete button clicks. Remove clicked link from the relatedlinks
    // textfield.
    $('.relatedlinks-delete', set).each(function(k) {
      $(this).click(function() {
        links_delete(k);
        links_preview();
        return false;
      });
    });

    // Handle up clicks. Move clicked link up one row.
    $('.relatedlinks-up', set).each(function(k) {
      $(this).click(function() {
        links_swap(k, k + 1);
        links_preview();
        return false;
      });
    });

    // Handle down clicks. Move clicked link down one row.
    $('.relatedlinks-down', set).each(function(k) {
      $(this).click(function() {
        links_swap(k, k + 1);
        links_preview();
        return false;
      });
    });

    // Update relatedlinks textarea.
    $(ta).val(l);
  }

  // Insert/update link input into global links array.
  function link_set(link, text, i) {
    links[i] = {url: $.trim(link), title: $.trim(text)};
  }

  // Delete link from global links array.
  function links_delete(k) {
    for (var i = k; i < links.length - 1; i++) {
      links[i] = links[i + 1];
    }
    links.pop();
    current = -1;
  }

  // Swap link orders.
  function links_swap(j, k) {
    if (k >= 0 && k < links.length) {
      var t = links[j];
      links[j] = links[k];
      links[k] = t;
    }
  }
});
